<template>
  <div class="player-section" :class="{ 'expand-section': isExpandPlayer }">
    <div v-show="!isExpandPlayer">
      <div class="wrap" v-if="music.url && !isMobile()" :class="!isMobile() ? 'desktop-wrap' : ''">
        <div class="player">
          <div class="player-left mr-auto">
            <img :src="music.photo" class="music-cover" />
            <div class="player-info">
              <span class="title">{{ music.title }}</span
              ><br />
              <span class="info">{{ music.artist || "Unknown" }}</span>
            </div>
            <span
              style="
              color: #ffffff;
              font-size: 1em;
              align-self: center;
              margin-left: 15px;
              cursor: pointer;"
              @click="likeSong"
            >
              <a-icon type="heart" />
            </span>
          </div>
          <div class="player-middle">
            <div class="control">
              <span title="Enable Shuffle" @click="shuffleSong"><a-icon type="swap"/></span>
              <span title="Previous" class="d-inline-flex justify-content-center align-items-center" @click="prevSong">
                <a-icon type="backward" style="font-size: 20px" />
              </span>
              <span
                :title="playing ? 'Pause' : 'Play'"
                style="font-size: 30px"
                class="d-inline-flex justify-content-center align-items-center"
              >
                <a-icon type="play-circle" v-if="!playing" @click="playMusic" theme="filled" />
                <a-icon theme="filled" type="pause-circle" v-if="playing" @click="pauseMusic" />
              </span>
              <span title="Next" class="d-inline-flex justify-content-center align-items-center" @click="nextSong">
                <a-icon type="forward" style="font-size: 20px" />
              </span>
              <span title="Repeat"><a-icon type="retweet" @click="repeatSong"/></span>
            </div>
            <div class="player-duration">
              <a-slider
                id="slider"
                :default-value="0"
                :max="duration"
                v-model="progress"
                :disabled="false"
                :step="1"
                :tip-formatter="formatter"
                @afterChange="goChange"
                @change="goChange"
              />
            </div>
          </div>
          <div class="player-right ml-auto" v-if="!isMobile()">
            <span title="Queues"><a-icon type="menu-fold"/></span>
            <span title="Devices"><a-icon type="mobile"/></span>
            <span title="Volumn"><a-icon type="sound"/></span>
            <a-slider
              class="volumn"
              :max="1"
              :default-value="1"
              :step="0.1"
              v-model="volumn"
              :disabled="false"
              @change="onChangeVolumn"
              :tip-formatter="formatVolumn"
            />
          </div>
        </div>
      </div>

      <div class="wrap-mobile" v-if="music.url && isMobile()" :class="{ 'desktop-wrap': !isMobile() }">
        <div class="player-mobile" @click.self="goPlayer">
          <div class="player-left">
            <span
              style="
              color: #ffffff;
              font-size: 1em;
              align-self: center;
              margin-left: 15px;
              cursor: pointer;"
            >
              <a-icon style="font-size: 1.4rem;" type="heart" />
            </span>
          </div>
          <div class="player-middle" @click="goPlayer">
            <div class="control">
              <div class="player-info" style="text-align:center">
                <span class="title">{{ music.title }} - {{ music.artist || "Unknown" }}</span
                ><br />
              </div>
            </div>
          </div>
          <div class="player-right-mobile">
            <span :title="playing ? 'Pause' : 'Play'" style="font-size:1.5em">
              <a-icon type="caret-right" style="font-size: 1.8rem;" v-if="!playing" @click="playMusic" />
              <a-icon type="pause" style="font-size: 1.8rem;" v-if="playing" @click="pauseMusic" />
            </span>
          </div>
        </div>
      </div>
    </div>

    <div
      class="player-expand d-flex flex-column"
      :class="{ mobile: isMobile(), expand: isExpandPlayer }"
      v-if="isMobile()"
    >
      <a-row class="player-header">
        <a-col :span="2"><a-icon type="down" @click="hidePlayer"></a-icon></a-col>
        <a-col :span="20" class="title">POP & Hiphop</a-col>
        <a-col :span="2"><a-icon type="more"></a-icon></a-col>
      </a-row>
      <a-row class="music-cover">
        <a-col :span="24">
          <img :src="music.photo" />
        </a-col>
      </a-row>
      <a-row class="music-info">
        <a-col :span="20">
          <p class="music-title text-left">{{ music.title }}</p>
          <p class="music-artist text-left">{{ music.artist || "Unknown" }}</p>
        </a-col>
      </a-row>
      <a-row class="player-duration mt-auto">
        <a-slider
          id="slider"
          :default-value="0"
          :max="duration"
          v-model="progress"
          :disabled="false"
          :step="1"
          :tip-formatter="formatter"
          @afterChange="goChange"
          @change="goChange"
        />
        <span class="current-time" v-show="progress">{{ currentTime }}</span>
        <span class="end-time" v-show="duration">{{ endTime }}</span>
      </a-row>
      <a-row class="pb-3">
        <a-col class="player-control" :span="24">
          <a-icon type="heart" class="heart-btn" @click="likeSong"></a-icon>
          <a-icon type="backward" class="prev-btn" @click="prevSong" />
          <a-icon type="play-circle" theme="filled" class="play-btn" v-show="!playing" @click="playMusic" />
          <a-icon type="pause-circle" theme="filled" class="play-btn" v-show="playing" @click="pauseMusic" />
          <a-icon type="forward" class="next-btn" @click="nextSong" />
          <a-icon type="retweet" class="repeat-btn" @click="repeatSong" />
        </a-col>
      </a-row>
    </div>
  </div>
</template>

<style scoped>
.ant-slider >>> div[role="slider"] {
  opacity: 0;
}
.ant-slider >>> .ant-slider-rail {
  opacity: 0.3;
}
.player-right-mobile {
  text-align: right;
  display: flex;
  flex-direction: row;
  align-self: center;
  margin-right: 16px;
  font-size: 1rem;
  color: #fff;
}
.wrap {
  background: #282828;
  border-top: 1px solid #010101;
  position: absolute;
  bottom: 0;
  left: 0;
  width: 100%;
  transition: all 0.3s;
  opacity: 1;
}
.wrap-mobile {
  background: #282828;
  border-top: 1px solid #010101;
  position: absolute;
  bottom: 69px;
  left: 0;
  width: 100%;
  transition: all 0.3s;
  opacity: 1;
}
.desktop-wrap .player {
  height: 90px;
  justify-content: center;
}
.desktop-wrap .player .player-left {
  display: flex;
  align-items: center;
  justify-content: flex-start;
  padding-left: 12px;
}
.desktop-wrap .music-cover {
  width: 70px;
  height: 70px;
  object-fit: cover;
}
.desktop-wrap .player .player-middle {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  padding-top: 16px;
  position: absolute;
  left: 50%;
  transform: translateX(-50%);
}
.desktop-wrap .player .player-duration {
  width: 450px;
}
.desktop-wrap .player .player-middle .control {
  display: flex;
  align-items: center;
  justify-content: center;
}
.player {
  height: 70px;
  min-height: 70px;
  z-index: 10;
  display: flex;
  justify-content: space-between;
  flex-wrap: wrap;
}
.player-mobile {
  height: 50px;
  min-height: 50px;
  z-index: 10;
  display: flex;
  justify-content: space-between;
  flex-wrap: wrap;
}

.player-left {
  display: flex;
  justify-content: space-between;
  flex-direction: row;
  flex-wrap: wrap;
}

.player-info {
  align-self: center;
  margin-left: 10px;
  text-align: left;
}

.player-info span {
  color: #ffffff;
}

.title {
  font-weight: bold;
  font-size: 1em;
}

.player-middle {
  align-self: center;
  width: 50%;
}

.control span {
  color: #ffffff;
  font-size: 1em;
  cursor: pointer;
  margin-left: 10px;
  margin-right: 10px;
}

.player-right {
  display: flex;
  flex-direction: row;
  align-self: center;
  margin-right: 10px;
  width: 200px;
}

.player-right span {
  color: #ffffff;
  font-size: 1em;
  cursor: pointer;
  margin-left: 10px;
  margin-right: 10px;
  align-self: center;
}

.volumn {
  width: 100px;
  align-self: center;
}

#slider {
  margin-left: 10px;
  margin-right: 10px;
}

/* Player Expand */
.expand-section {
  height: 100vh;
}
.player-expand {
  overflow: auto;
  height: 0;
  position: relative;
  top: calc(100% - 68px);
  z-index: 999;
  background: #121212;
}
.player-expand.expand {
  top: 0;
  min-height: 100%;
  transition: all 0.4s ease;
}
.player-expand > * {
  display: none;
}
.player-expand.expand > * {
  display: block;
}
.player-expand .player-header {
  padding: 22px 16px 16px;
}
.player-expand .player-header .title {
  font-weight: 500;
  font-size: 18px;
  text-align: center;
  letter-spacing: -0.24px;
  color: #f1f1f1;
}
.player-expand .player-header i {
  color: #fff;
  font-size: 24px;
}
.player-expand .music-cover > div {
  padding: 0 24px;
}
.player-expand .music-cover img {
  width: 100%;
  height: 46vh;
  object-fit: cover;
}
.player-expand .music-info {
  padding: 22px 22px 0;
}
.player-expand .music-title {
  font-weight: 500;
  font-size: 24px;
  color: #ffffff;
  margin: 0;
  display: -webkit-box;
  -webkit-box-orient: vertical;
  -webkit-line-clamp: 2;
  overflow: hidden;
}
.player-expand .music-artist {
  font-weight: 300;
  font-size: 14px;
  color: #ffffff;
  margin: 0;
  display: -webkit-box;
  -webkit-box-orient: vertical;
  -webkit-line-clamp: 1;
  overflow: hidden;
}
.player-expand .player-duration {
  padding: 16px 20px 0;
}
.player-expand .current-time,
.player-expand .end-time {
  position: absolute;
  color: #fff;
  opacity: 0.7;
}
.player-expand .current-time {
  left: 30px;
  bottom: -14px;
}
.player-expand .end-time {
  right: 30px;
  bottom: -14px;
}
.player-control {
  padding-top: 24px;
  display: flex;
  align-items: center;
  justify-content: center;
}
.player-control i {
  color: #fff;
}
.play-btn {
  font-size: 66px;
}
.prev-btn,
.next-btn {
  font-size: 40px;
  margin: 0 24px;
}
.heart-btn,
.repeat-btn {
  font-size: 22px;
}
</style>

<script>
import { Howl, Howler } from "howler";
import { mapState } from "vuex";

export default {
  data() {
    return {
      sound: null,
      soundId: null,
      playing: false,
      duration: 0,
      progress: 0,
      volumn: 1,
      isExpandPlayer: false,
      currentPlaylist: [],
      currentMusic: {},
      typePlay: "normal"
    };
  },
  computed: {
    ...mapState({
      music: (state) => state.player.music
    }),
    currentTime() {
      let result = this.formatter(this.progress);
      return result;
    },
    endTime() {
      let result = this.formatter(this.duration);
      return result;
    }
  },
  watch: {
    music: {
      deep: true,
      handler(val) {
        this.currentMusic = val;

        if (this.sound) {
          this.sound.stop();
        }

        let sound = new Howl({
          src: [val.url],
          html5: true
        });
        console.log("🚀 ~ file: Player.vue ~ line 460 ~ handler ~ sound", sound)
        sound.on("load", () => {
          this.soundId = sound.play();
        });
        sound.on("play", () => {
          this.playing = true;
          this.duration = sound.duration();
          this.startRun();
        });
        sound.on("pause", () => {
          this.playing = false;
        });
        sound.on("end", () => {
          this.playing = false;
          this.soundId = null;
          this.sound = null;
          this.progress = 0;
          this.duration = 0;
          sound.off();
          sound.unload();
          this.nextSong();
        });

        this.sound = sound;
        this.progress = 0;
        this.sound.load();
      }
    },
    "$store.state.player.playlist"(val) {
      this.currentPlaylist = val;
    }
  },
  methods: {
    isMobile() {
      if (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent)) {
        return true;
      } else {
        return false;
      }
    },
    formatter(value) {
      let minutes = Math.floor(value / 60);
      let s = Math.round(value % 60);
      let str = "";
      if (minutes < 10) {
        str = "0" + minutes;
      } else {
        str = minutes + "";
      }
      if (s < 10) {
        str += ":" + "0" + s;
      } else {
        str += ":" + s;
      }
      return str;
    },
    formatVolumn(value) {
      return value * 10;
    },
    playMusic() {
      if (this.music.url) {
        if (this.sound) {
          this.sound.play();
        }
      }
    },
    pauseMusic() {
      if (this.music.url) {
        if (this.sound) {
          this.sound.pause();
        }
      }
    },
    nextSong() {
      this.currentPlaylist.forEach((item, ind) => {
        if (item.id !== this.currentMusic.id) return;

        let newInd;
        if (ind === this.currentPlaylist.length - 1) {
          newInd = 0;
        } else {
          newInd = ind + 1;
        }

        let newMusic = this.currentPlaylist[newInd];

        this.$store.dispatch("player/playMusic", newMusic);
      });
    },
    prevSong() {
      this.currentPlaylist.forEach((item, ind) => {
        if (item.id !== this.currentMusic.id) return;

        let newInd;
        if (ind === 0) {
          newInd = this.currentPlaylist.length - 1;
        } else {
          newInd = ind - 1;
        }

        let newMusic = this.currentPlaylist[newInd];

        this.$store.dispatch("player/playMusic", newMusic);
      });
    },
    repeatSong() {
      this.typePlay = "repeat";
    },
    shuffleSong() {
      this.typePlay = "shuffle";
    },
    likeSong() {},
    async startRun() {
      while (this.playing) {
        this.progress = this.sound.seek();
        await new Promise((r) => setTimeout(r, 1000));
      }
    },
    onChangeVolumn(v) {
      Howler.volume(v);
    },
    goChange(v) {
      if (this.music.url) {
        if (this.sound) {
          this.sound.seek(this.progress);
        }
      }
    },
    goPlayer() {
      this.isExpandPlayer = true;
    },
    hidePlayer() {
      this.isExpandPlayer = false;
    }
  }
};
</script>
